/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package dialog;

import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Image;
import ihm.FenetrePrincipale;
import javax.swing.JFrame;
import javax.swing.JPanel;


/**
 * Classe permettant d'afficher le a propos
 * Utilise dans fenetre principale
 * @author docet
 *
 */
public class APropos extends JFrame 
{
	private static final long serialVersionUID = 1L;
	private Image im;
	private static final String[] TEXTE = {
		"This program was developped during a internship.",
		"developers : Eric DOCET & Etienne GIRAUDET",
		"advisor : Jeremie BOURDON"
		};
	
	public APropos()
	{
		im = getToolkit().getImage("files/lina.gif");
		setTitle("About "+FenetrePrincipale.NOM_LOGICIEL);
		
		JPanel pTout = new JPanel(){
			private static final long serialVersionUID = 1L;
			public void paint(Graphics g)
			{
				g.drawImage(im, 100, 0, 205, 121, null);
				FontMetrics fm = g.getFontMetrics();
				int a = fm.getMaxAscent();
				int b = fm.getMaxDescent();
				int texteY = 150 - b/2 + a/2;
				for(int i=0; i<TEXTE.length; i++)
				{
					int longTexte = fm.stringWidth(TEXTE[i]);
					int texteX = 400/2 - longTexte/2;
					g.drawString(TEXTE[i], texteX, texteY);
					texteY = texteY + a + b + 5;
				}
			}
		};
		add(pTout);
		setFocusable(true);
		setSize(400,250);
		setResizable(false);
		setLocationRelativeTo(FenetrePrincipale.getInstance());
		repaint();
		setVisible(true);
	}
	
}
