/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package dialog;


import ihm.FenetrePrincipale;
import ihm.intervalle.Intervalle;
import ihm.intervalle.IntervalleGraphique;
import ihm.transition.Transition;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

/**
 * Dialog utliser pour modifier les intervalles sur les transitions
 * @author giraudet-docet
 *
 */
public class DialogIntervalle extends JDialog 
{
	private static final long serialVersionUID = 1L;
	protected JTextField tfNom;
	protected IntervalleGraphique newi;
	protected Intervalle intervalle;
		
	public DialogIntervalle(final IntervalleGraphique iv, JButton valider, String defText, final Transition t)
	{
		super(FenetrePrincipale.getInstance());
		newi = iv;
		intervalle = newi.getIntervalle();
		tfNom = new JTextField(newi.getDescription(),20);
		tfNom.setText(defText);
		JPanel p = new JPanel();
		p.add(tfNom);
		p.add(newi);
		p.add(valider);
		add(p);
		setResizable(false);
		setSize(300,250);
		setLocationRelativeTo(getParent());
		setVisible(true);
		
		
		tfNom.getDocument().addDocumentListener(new DocumentListener()
				{
					public void insertUpdate(DocumentEvent e){
						newi.setDescription(tfNom.getText());
						newi.repaint();
					}
					public void removeUpdate(DocumentEvent e){
						newi.setDescription(tfNom.getText());
						newi.repaint();
					}
					public void changedUpdate(DocumentEvent e){
					}
				});
		
		valider.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						newi.sauverValeurs();
						intervalle.setDescription(iv.getDescription());
						dispose();
					}
				});
	}
	
}
