/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package dialog;

import ihm.Application;
import ihm.FenetrePrincipale;
import ihm.intervalle.Intervalle;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import util.JFloatField;
import util.JIntField;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import cout.Cout;
/**
 * Dialog utilise dans le cas d'une modification d'un cout
 * @author giraudet-docet
 *
 */
public class DialogModifieCout extends JDialog{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public DialogModifieCout(final Cout c,JButton valider,JButton annuler)
	{
		super(FenetrePrincipale.getInstance());
		JPanel pTout = new JPanel();
		JLabel lnom = new JLabel(Application.langue.getProperty("nom2"));
		final JTextField tnom = new JTextField(20);
		tnom.setText(c.getNom());
		JLabel lideal = new JLabel(Application.langue.getProperty("lideal"));
		JLabel lmin = new JLabel(Application.langue.getProperty("Min"));
		JLabel lmax = new JLabel(Application.langue.getProperty("Max"));
		final JFloatField tmin = new JFloatField(20);
		tmin.setFloat(c.getIdeal().getMinDouble().floatValue()*c.getDuree());
		final JFloatField tmax = new JFloatField(20);

		JLabel _long = new JLabel(Application.langue.getProperty("long"));
		final JIntField fLong = new JIntField(10);
		fLong.setInt(c.getDuree());
		tmax.setFloat(c.getIdeal().getMaxDouble().floatValue()*c.getDuree());
		JLabel text = new JLabel(Application.langue.getProperty("clickInformation"));
		JPanel pnom = new JPanel();
		pnom.add(lnom);
		pnom.add(tnom);
		JPanel ptext = new JPanel();
		ptext.add(text);
		JPanel pideal = new JPanel();
		pideal.add(lideal);
		JPanel pmin = new JPanel();
		JPanel pmax = new JPanel();
		pmin.add(lmin);
		pmin.add(tmin);
		pmax.add(lmax);
		pmax.add(tmax);
		JPanel plong= new JPanel();
		plong.add(_long);
		plong.add(fLong);
		pTout.add(pnom);
		pTout.add(ptext);
		pTout.add(pideal);
		pTout.add(pmin);
		pTout.add(pmax);
		pTout.add(plong);
		
		valider.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				c.setNom(tnom.getText());
				if(tmin.getFloat()<=tmax.getFloat())
				{
					int n = fLong.getInt();
					c.setDuree(n);
					c.setIdeal(new Intervalle(tmin.getFloat()/n,tmax.getFloat()/n));
					dispose();
				}
				else
				{
					JOptionPane.showMessageDialog(FenetrePrincipale.getInstance(), Application.langue.getProperty("erreurborne"), "ERROR", JOptionPane.ERROR_MESSAGE);
				}
			}
		});
		annuler.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				dispose();
			}
		});
		JPanel pBouton = new JPanel();
		pBouton.add(valider);
		pBouton.add(annuler);
		pTout.add(pBouton);
		add(pTout);
		setSize(300,300);
		setResizable(false);
		setLocationRelativeTo(getParent());
		setVisible(true);
	}
}
