/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package dialog;

import ihm.Application;
import ihm.FenetrePrincipale;
import ihm.etat.EtatGraphique;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import util.JFloatField;

import cout.CoutMult;

/**
 * Dialog servant a cree le vecteur de probabilite pour les couts multiplicatifs
 * @author giraudet
 *
 */
public class DialogVecteurProba extends JDialog{
			
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public DialogVecteurProba(final int nbEtat,final CoutMult c,JButton valider,JButton annuler)
	{
		JPanel pTout = new JPanel()
		{
			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;

			public Dimension getMinimumSize()
			{
				return new Dimension(250,250);
			}
			
			public Dimension getPreferredSize()
			{
				return this.getMinimumSize();
			}
			
			public Dimension getMaximumSize()
			{
				return this.getMinimumSize();
			}
		};
		ArrayList<EtatGraphique> le = FenetrePrincipale.getInstance().getEspaceTravail().getDessinGraphe().graphe.listeEtats;
		JScrollPane jsp = new JScrollPane(pTout);
		pTout.setLayout(new BoxLayout(pTout,BoxLayout.Y_AXIS));
		final ArrayList<JFloatField> ljf = new ArrayList<JFloatField>();
		float somme =0f;
		for(int i=0;i<nbEtat;i++)
		{
			JPanel jp = new JPanel();
			JFloatField jf = new JFloatField(6);
			if(i!=nbEtat-1)
			{
				jf.setFloat((float)(Math.round(1f*10000/nbEtat))/10000);
				somme+=(float)(Math.round(1f*10000/nbEtat))/10000;
			}
			else
				jf.setFloat(1-somme);
			
			ljf.add(jf);
			JLabel jl = new JLabel(""+le.get(i));
			jp.add(jl);
			jp.add(jf);	
			pTout.add(jp);
		}
		JPanel pBouton = new JPanel();
		valider.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				ArrayList<Double> vp = new ArrayList<Double>();
				float somme=0;
				for(int i=0;i<nbEtat;i++)
				{
					vp.add(ljf.get(i).getFloat());
					somme+=ljf.get(i).getFloat();
				}
				if(somme==1)
				{
					c.setVecteurProba(vp);
					dispose();
				}
				else
					JOptionPane.showMessageDialog(getParent(),Application.langue.getProperty("erreurdvp"),null,JOptionPane.INFORMATION_MESSAGE);
			}
		});
		annuler.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				dispose();
			}
		});
		pBouton.setLayout(new BoxLayout(pBouton,BoxLayout.X_AXIS));
		pBouton.add(valider);
		pBouton.add(annuler);
		pTout.add(pBouton);
		setLayout(new BorderLayout());
		pTout.setBorder(BorderFactory.createTitledBorder(Application.langue.getProperty("vectproba")));
		add(jsp,BorderLayout.CENTER);
		setSize(300,300);
		setVisible(true);
	}
}
