/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package ihm.dessin;

import ihm.chemin.Chemin;
import ihm.transition.Transition;

import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;
import dialog.DialogAjoutChemin;
/**
 * Classe qui herite de DessinGrapheState et qui correspond au cas ou on ajoute une transition au graphe
 * @author Docet Giraudet
 *
 */
public class DessinGrapheStateAddChemin extends DessinGrapheState
{
	private static final long serialVersionUID = 1L;
	private Chemin cheminEnCours;
/**
 * On redefinie le constructeur dans le lequel on cree un nouveau chemin
 * @param dg
 */
	public DessinGrapheStateAddChemin(final DessinGraphe dg) 
	{
		super(dg);
		cheminEnCours = new Chemin(dg.graphe,"",1);
		DialogAjoutChemin dac = new DialogAjoutChemin(cheminEnCours,_dg.getChemins().size()+1);
		dac.addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				dg.menuTraitement.enabledChemin(false);
				dg.menuTraitement.setCheminEnCours(false);
				dg.getChemins().remove(cheminEnCours);
			}	
		});
		_dg.getChemins().add(cheminEnCours);
	}

	public  void mouseClicked(MouseEvent e) {
	}
	
	/**
	 * On rajoute transition par transition
	 */
	public  void mousePressed(MouseEvent e) {
		ArrayList<Transition> t = _dg.getListeTransition();
		cheminEnCours.setColorTransition();
		Transition trans = _dg.getTransitionSelectionne();
		if(trans!=null)
		{
		int num = trans.getEtatArrivee().getnum();
		for(int i=0;i<t.size();i++)
			if(t.get(i).getEtatDepart().getnum()==num)
				t.get(i).setColorSel(Color.BLUE);
		trans.setColorSel(Color.RED);
		_dg.repaint();
		cheminEnCours.add(trans);
		}
	}
	
	public  void mouseReleased(MouseEvent e) {
	}
	
	public  void mouseEntered(MouseEvent arg0) {
	}

	public  void mouseExited(MouseEvent e) {
	}
	
	public  void mouseDragged(MouseEvent e) {
	}
	
	public  void mouseMoved(MouseEvent arg0) {
	}
	
}
