/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package ihm.dessin;

import ihm.Application;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import javax.swing.JButton;

import cout.Cout;
import cout.CoutMult;
import cout.CoutP1;
import dialog.DialogAjoutCoutMultTransition;
import dialog.DialogAjoutCoutTransition;
/**
 * etat du dessin grpahe correspondant au moment ou on ajoute un cout au graphe
 * @author giraudet-docet
 *
 */
public class DessinGrapheStateAddCout extends DessinGrapheState{
	
	private Cout _c;
	private boolean add;
	
	public DessinGrapheStateAddCout(DessinGraphe dg,Cout c,boolean _add)
	{
		super(dg);
		_c=c;
		add=_add;
	}

	@Override
	public void mouseClicked(MouseEvent e) {
	}


	@Override
	/**
	 * si on clique sur une transition on ouvre la dialog qui permet de modifier le cout sur une
	 * transition
	 */
	public void mousePressed(MouseEvent e) 
	{
		if(_dg.getTransitionSelectionne()!=null)
		{
		JButton valider = new JButton(Application.langue.getProperty("valider"));
		if(add)
			new DialogAjoutCoutTransition(_dg.graphe,valider,((CoutP1) _c).getMatrice(),_dg.getTransitionSelectionne());
		else
			new DialogAjoutCoutMultTransition(_dg.graphe,valider,((CoutMult)_c).getMatrice(),_dg.getTransitionSelectionne());
		valider.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{

				_dg.setTransitionSelectionne(null);
			}
		});
		}
		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
	}

	@Override
	public void mouseEntered(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseDragged(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseMoved(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

}
