/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package ihm.transition;

import java.awt.Graphics;
import java.awt.Point;
/**
 * Classe servant a representer une fleche
 * @author giraudet-docet
 *
 */
public class Fleche 
{
	private Point pDep;
	private Point pArr;
	static double pi = Math.PI;
	
	public Fleche(Point p1, Point p2)
	{
		pDep = p1;
		pArr = p2;
	}
	public Fleche(int a, int b, int c, int d)
	{
		pDep = new Point(a,b);
		pArr = new Point(c,d);
	}
	
	public void dessineFleche(Graphics g)
	{
		dessineTrait(g);
		dessineBoutFleche(g);
	}
	
	private void dessineTrait(Graphics g)
	{
		g.drawLine(pDep.x,pDep.y,pArr.x,pArr.y);
	}
	
	private void dessineBoutFleche(Graphics g)
	{
		if(!(pDep.x==pArr.x && pDep.y==pArr.y))
		{
			double x3, y3, x4, y4;
			int l = 10;
			double a = pi/6 ;
			double L = Math.sqrt(Math.pow(pArr.x - pDep.x, 2) + Math.pow(pArr.y - pDep.y, 2));
			x3 = pArr.x - l * ((pArr.x - pDep.x) / L * Math.cos(a) + (pArr.y - pDep.y) / L * Math.sin(a));
			y3 = pArr.y + l * ((pArr.x - pDep.x) / L * Math.sin(a) - (pArr.y - pDep.y) / L * Math.cos(a));
			x4 = pArr.x - l * ((pArr.x - pDep.x) / L * Math.cos(-a) + (pArr.y - pDep.y) / L * Math.sin(-a));
			y4 = pArr.y + l * ((pArr.x - pDep.x) / L * Math.sin(-a) - (pArr.y - pDep.y) / L * Math.cos(-a));
			
			g.drawLine(pArr.x, pArr.y, (int) x3, (int) y3);
			g.drawLine(pArr.x, pArr.y, (int) x4, (int) y4);		
		}	
	}
	
	
	
}
