/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package thread;

import ihm.Application;
import ihm.FenetrePrincipale;
import ihm.intervalle.Intervalle;

import java.awt.BorderLayout;
import java.util.ArrayList;

import javax.swing.JDialog;
import javax.swing.JLabel;


import calcul.CalculVolume;
import calcul.Matrice;
import calcul.MethodeResolution;


/**
 * classe representant le processus du calcul du volume
 * @author giraudet
 *
 */
public class StartCalculVolume extends ThreadCalcul{


	private CalculVolume cv;
	private boolean _affiche;
	
	
	public StartCalculVolume(Matrice<Intervalle> mi , int nbEtat ,ArrayList<MethodeResolution> mr,int nbp,int dim,boolean affiche)
	{
		
		cv = new CalculVolume(mi,nbEtat,mr,nbp,dim);
		statut=Application.langue.getProperty("statut");
		nom=Application.langue.getProperty("nomscv")+"°"+cv.getnum();
		_affiche=affiche;
		
	}
	
	public void run()
	{
		
		cv.start();
		while(!cv.semaphore.tryAcquire())
		{
			if(isInterrupted())
				break;
		}
		if(!isInterrupted())
		{
			statut=Application.langue.getProperty("statutfin");
			if(_affiche)
				AfficherResultat();
			else
				FenetrePrincipale.getInstance().getEspaceTravail().getMenuTraitement().majThread();
		}
	}

	@Override
	public void AfficherResultat() {
		JDialog jd = new JDialog(FenetrePrincipale.getInstance(),Application.langue.getProperty("nomscv")+cv.getnum());
		JLabel jl= new JLabel(Application.langue.getProperty("resultscv")+" "+cv.getVolume());
		jd.add(jl,BorderLayout.CENTER);
		jd.setSize(400,50);
		jd.setLocationRelativeTo(FenetrePrincipale.getInstance());
		jd.setVisible(true);
		cv.affiche3D();
		
	}
	
	public void interrupt()
	{
		cv.interrupt();
	}
	
}
